Package org.eclipse.m2m.atl.core.ui.vm.debug

# Class LocalObjectReference

java.lang.Object
org.eclipse.m2m.atl.debug.core.adwp.Value
org.eclipse.m2m.atl.debug.core.adwp.ObjectReference
org.eclipse.m2m.atl.core.ui.vm.debug.LocalObjectReference

public class LocalObjectReference extends ObjectReference
The local implementation of an object reference.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`LocalObjectReference.ADWPStackFrame`
A `StackFrame` for the debugging protocol, which doesn't interfere with the debugging process.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected NetworkDebugger`
`debugger`
`protected Object`
`object`

### Fields inherited from class org.eclipse.m2m.atl.debug.core.adwp.ObjectReference

`id`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`LocalObjectReference(Object object, int id, NetworkDebugger debugger)`
Creates a new LocalObjectReference.

## Method Summary

Modifier and Type
Method
Description
`static Value`
`asm2value(ASMOclAny o, NetworkDebugger debugger)`
Converts an ASM Object into a `Value`.
`Value`
`call(String opName, List<Value> args)`
Calls an operation with the given arguments.
`Value`
`get(String propName)`
Gets a value for the given property.
`Object`
`getObject()`
`void`
`set(String propName, Value value)`
Sets a value for the given property.
`String`
`toString()`
`static ObjectReference`
`valueOf(int objectId)`
Returns the object reference matching the given id.
`static ObjectReference`
`valueOf(Object object, NetworkDebugger debugger)`
Returns an object reference for the given object.

### Methods inherited from class org.eclipse.m2m.atl.debug.core.adwp.ObjectReference

`getId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### object

protected Object object

### debugger

protected NetworkDebugger debugger

## Constructor Details

### LocalObjectReference

protected LocalObjectReference(Object object, int id, NetworkDebugger debugger)
Creates a new LocalObjectReference.

Parameters:
  `object` - the object
  `id` - the objecct id
  `debugger` - the debugger

## Method Details

### getObject

public Object getObject()

### toString

public String toString()

Overrides:
  `toString` in class `ObjectReference`
See Also:
  - `ObjectReference.toString()`

### valueOf

public static ObjectReference valueOf(int objectId)
Returns the object reference matching the given id.

Parameters:
  `objectId` - the object id
Returns:
  the object reference matching the given id

### valueOf

public static ObjectReference valueOf(Object object, NetworkDebugger debugger)
Returns an object reference for the given object.

Parameters:
  `object` - the object
  `debugger` - the current debugger
Returns:
  the object reference

### get

public Value get(String propName)
Gets a value for the given property.

Specified by:
  `get` in class `ObjectReference`
Parameters:
  `propName` - the property name
Returns:
  the value
See Also:
  - `ObjectReference.get(java.lang.String)`

### set

public void set(String propName, Value value)
Sets a value for the given property.

Specified by:
  `set` in class `ObjectReference`
Parameters:
  `propName` - the property name
  `value` - the value to set
See Also:
  - `ObjectReference.set(java.lang.String, org.eclipse.m2m.atl.debug.core.adwp.Value)`

### call

public Value call(String opName, List<Value> args)
Calls an operation with the given arguments.

Specified by:
  `call` in class `ObjectReference`
Parameters:
  `opName` - the operation name
  `args` - the arguments
Returns:
  the operation call result
See Also:
  - `ObjectReference.call(java.lang.String, java.util.List)`

### asm2value

public static Value asm2value(ASMOclAny o, NetworkDebugger debugger)
Converts an ASM Object into a `Value`.

Parameters:
  `o` - the object
  `debugger` - the current debugger
Returns:
  the `Value`